package decrypto;

public interface Solver
{
    public void addListener(SolverListener listener);

    /** Asynchronously begin solving.**/
    public void start(double maxTime); 

    public void stop();

    /** How much time has been used for solving thus far? **/
    public double getElapsedTime();

    /** Returns any exception that might have terminated the solver erroneously. **/
    public Exception getException();
}
