package decrypto.dictattack;

import decrypto.*;

import java.util.*;

/** Planner determines what we do at every step of the search **/
public class RandomPlanner implements Planner
{
    Random r = new Random();
    Puzzle puzzle;

    public RandomPlanner(Puzzle puzzle)
    {
	this.puzzle = puzzle;
    }

    public int getAction(boolean solvedWords[], MapSet map)
    {
	int trials = 0;

	while (true) {
	    int widx = r.nextInt(solvedWords.length);
	    trials++;

	    // XXX Hack.  We can have all words either solved or
	    // disabled. we need to detect this more gracefully.
	    if (trials > solvedWords.length*10)
		return -1;

	    if (solvedWords[widx] || !puzzle.words.get(widx).enabled)
		continue;

	    return Planner.WORD_FLAG | widx;
	}
    }
}
