package decrypto.genetic;

public class Sampler<T>
{
    double proportions[];
    T      objs[];

    double totalProportion;

    public Sampler(double proportions[], T objs[])
    {
	assert (proportions.length == objs.length);
	
	this.proportions = proportions;
	this.objs = objs;
	
	for (int i = 0; i < proportions.length; i++)
	    totalProportion += proportions[i];
    }

    public T sample(double v)
    {
	v *= totalProportion;

	// this dumb implementation is the fastest when proportions
	// are sorted from biggest to smallest.
	for (int i = 0; i < proportions.length; i++) {
	    v -= proportions[i];
	    if (v < 0) {
		//System.out.printf("%10d %15f %d\n", proportions.length, v, i);
		return objs[i];
	    }
	}

	// in case of rounding errors.
	assert(false);
	return objs[0]; 
    }
}
