#include <stdio.h>
#include <ctype.h>
#include <math.h>

char lastchar = ' ';

double count[27][27];
double total[27];
double grandtotal;

void update(char c)
{
	if (c==' ' && lastchar ==' ')
		return;

	int ia, ib;
	if (lastchar==' ')
		ia = 26;
	else
		ia = lastchar-'A';

	if (c==' ')
		ib = 26;
	else
		ib = c-'A';

	if (ib<0 || ib>26)
		printf("ERR: %i %c\n", ib, c);

	count[ia][ib]++;
  
	lastchar = c;

}

int main(int argc, char *argv[])
{
	char c;

	for (int i=0;i<27;i++)
		for (int j=0;j<27;j++)
			count[i][j]=0;

	while ((c=fgetc(stdin))!=EOF)
	{
		if (isalpha(c))
			update(toupper(c));
		else if (c=='\'')
			continue;
		else
			update(' ');
	}

	grandtotal = 0;

	for (int i=0;i<27;i++) {
		total[i] = 0;
		
		for (int j=0;j<27;j++) {
			if (count[i][j]==0)
				count[i][j]=1;
			else
				count[i][j]*=4;

			total[i]+=count[i][j];
		}

		grandtotal += total[i];

		for (int j=0;j<27;j++) {
			count[i][j]=log(count[i][j]/total[i]);
		}
	}

	printf("{ ");
	for (int i=0;i<27;i++) {
		printf("{ ");
		for (int j=0;j<27;j++) {
			printf("%e", count[i][j]);
			if (j<26)
				printf(", ");
			if (j%4==3) {
				printf("\n");
			}
		}  
		printf("} ");
		if (i<26)
			printf(", ");
		printf("\n");
	}
	printf("};\n");

	printf("{ \n");
	for (int i=0;i<27;i++) {
		printf("%e", log(total[i]/grandtotal));
		if (i<26)
			printf(", ");
		printf("\n");
	}
	printf("};\n");
}


