<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
<head>
<title>Decrypto 8.5, Online Cryptoquip and Cryptogram Solver</title>
<link href=styles.css rel=stylesheet type="text/css">
<link rel="icon" href="favicon.ico" />
<link rel="shortcut icon" href="favicon.ico" />
</head>

<?php

 //////////////////////////////////////////////////
 // parse request


$clues="";
$partial=10;
$dictionary="";
$ciphertext="";

$MAXTIME = 10;  // no one is allowed to exceed this, no matter what.
$timelimit = 10;
$mode = 1;

@$ciphertext = $_REQUEST["ciphertext"];
@$clues = $_REQUEST["clues"];
@$dictionary = $_REQUEST["dictionary"];

if (isset($_REQUEST["timelimit"]))
  $timelimit = $_REQUEST["timelimit"];

if (isset($_REQUEST["mode"]))
    $mode = $_REQUEST["mode"];

if ($timelimit < 5)
  $timelimit = 5;
if ($timelimit > $MAXTIME)
  $timelimit = $MAXTIME;

if ($dictionary=="")
  $dictionary=2;

$PAGESIZE=10;
$HTMLDIR=getcwd();
$JAVA="/opt/jdk/bin/java";
$JAR="$HTMLDIR/decrypto.jar";
$SETSIZE=100;
$FLAGS="";

/*
if ($dictionary==1)
  $FLAGS=$FLAGS." --dictionary=$HTMLDIR/english-tiny.dat";
if ($dictionary==2)
  $FLAGS=$FLAGS." --dictionary=$HTMLDIR/english-standard.dat";
if ($dictionary==3)
  $FLAGS=$FLAGS." --dictionary=$HTMLDIR/english-large.dat";
*/

$FLAGS=$FLAGS." --dictionary=$HTMLDIR/english-standard.dat";

$FLAGS=$FLAGS." --setsize=$SETSIZE";
$cmd="$JAVA -cp $JAR decrypto.DecryptoCGI $FLAGS";

?>

<div id="content">

<script type="text/javascript">
var bestscore = -99999999;
var sol_scores = new Array();
var sol_solutions = new Array();
var sol_max = 0;
var num_sols = 0;
var PAGESIZE = <?php print $PAGESIZE?>;
var page = 0;
var totaltime = 0;

function prg(p)
{
  var t = 50;
  var v = p*t;

  if (v==0)
    v="1px";
  else
    v=v+"%";

  document.getElementById('progressLeftId').style.paddingRight  = v;
  document.getElementById('progressLeftId').style.paddingLeft   = v;
}

function sol(score, solution)
{
  num_sols++;
  document.getElementById('numsolsId').innerHTML=num_sols;

  if (score>bestscore)
    {
      document.getElementById('score0').innerHTML=score;
      document.getElementById('sol0').innerHTML=solution;
      bestscore=score;
    }
  else
    {
      document.getElementById('score1').innerHTML=score;
      document.getElementById('sol1').innerHTML=solution;      
    }
}

function msg(msg)
{
  document.getElementById('msgId').innerHTML=msg;
}

function elapse(t)
{
  totaltime=t;
}

function solsum(rank, score, solution)
{
  sol_scores[rank]=score;
  sol_solutions[rank]=solution;
  if (rank>sol_max)
    sol_max=rank;
}

var page=0;

function next(dir)
{
  page+=dir;

  if (page<0)
    page=0;

  if (page>sol_max/PAGESIZE)
    page=parseInt(sol_max/PAGESIZE);

  offset = page*PAGESIZE;

  for (i=0; i<PAGESIZE; i++)
    {
      document.getElementById("rank"+i).innerHTML=i+offset+1;
      s = sol_scores[i+offset];
      document.getElementById("score"+i).innerHTML= s==null ? "&nbsp;" : s;
      s = sol_solutions[i+offset];
      document.getElementById("sol"+i).innerHTML= s==null ? "&nbsp;" : s;
    }
}

</script>

<table width="100%">
<tr>
<td valign=top><img alt="logo" src=decrypto2.png><td valign=middle>
<P><I>A fast and automated cryptogram solver by <a href="mailto:eolson@mit.edu">Edwin Olson</a>. A stand-alone version of the program is available <a href="http://www.blisstonia.com/software/Decrypto">here</a>. <a href="help.php">Online Help</a> is also available.</I></P>
</table><hr><br>

<!-- ******************* INPUT FORM ********************** -->

<form method=post action=index.php>
<table width="100%">
<tr><td valign=top>Puzzle:
<td><textarea rows=3 cols=80 style="width: 100%" id=ciphertextId name=ciphertext>
<?php print $ciphertext ?>
</textarea>

<tr><td>Clues:<td>
<textarea style="width: 100%" rows=1 cols=80  id=cluesId name=clues>
<?php print $clues ?>
</textarea>

<tr><td>&nbsp;<td align=right>
<select name=mode>
<option <?php if ($mode==1) print "selected" ?> value=1>Trust spaces (Cryptogram mode)</option>
<option <?php if ($mode==2) print "selected" ?> value=2>Find spaces (Patristocrat mode)</option>
</select>

<input type=submit name="action" value="Scramble" accesskey="M">
<input type=submit name="action" value="Solve" accesskey="S">

</table>
</form>

<?php

if ($_REQUEST["action"]=="Solve")
  {
      print "<hr>";
/*      print "<P>2008-08-10: A note to my regular users: Decrypto received an
unusually high number of requests on August 9th which ultimately overloaded the server and disrupted all of the services (not just WebDecrypto) that it provides. It appears that Decrypto was mentioned in a contest on a website, and that potentially hundreds of users descended on it at once. 

<P>In an important way, this is fantastic. Without users, writing software is wasted effort. In this case, though, the load exceeded the capacity. I've added some additional limits to WebDecrypto to try to make sure it can meet higher capacities, but this is just a single machine with finite resources. Remember that the <a href=http://www.blisstonia.com/software/Decrypto>standalone version</a> is faster, has additional solving options, and won't load the server. Best, it's still free (though I always appreciate <a href=http://www.blisstonia.com/software/donations.php>contributions</a>!)

<P>-Edwin";
*/
      $waittry = 0;
      while (true) {
          $concurrentRequests = intval(shell_exec("ps aux | grep decrypto.DecryptoCGI | grep java | wc -l")) - 1;
          $loads = sys_getloadavg();
          $load = $loads[0];
          print "<P>There are currently $concurrentRequests other user(s) running puzzles. (System load is $load).";
          if ($concurrentRequests < 5 && $load < 4)
              break;
          $waittry++;
          if ($waittry > 5) {
              print "We're still busy. Please try again later, or use the <a href=http://www.blisstonia.com/software/Decrypto>standalone version</a>. If this situation persists, please let the <a href=mailto:eolson@mit.edu>administrator</a> know!";
              exit(0);
          } else {
              print ".. please wait (do not reload)";
          }
          for ($i = 0; $i < 5; $i++) {
              print ".";
              ob_implicit_flush(1);
              @ob_flush();
              flush();
              sleep(1);
          }
      }
      print ".. It's your turn!<br>";

      include("solve.php");

  }

if ($_REQUEST["action"]=="Scramble")
  {
    include("scramble.php");
  }
?>

</div>
</html>
