;--------------------------------
;Include Modern UI

!include "MUI.nsh"
SetCompressor lzma
 
;Start Menu Folder Page Configuration
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU" 
!define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\WinDecrypto" 
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"
 
;--------------------------------
;General

  ;Name and file
  Name "WinDecrypto"
  OutFile "WinDecryptoSetup.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\WinDecrypto"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\WinDecrypto" ""

;--------------------------------
;Variables

  Var MUI_TEMP
  Var STARTMENU_FOLDER

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;5A
;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "../License.txt"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  
  !insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER
  !insertmacro MUI_PAGE_INSTFILES

  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

  !define MUI_FINISHPAGE_RUN "$INSTDIR\WinDecrypto.exe"
  !insertmacro MUI_PAGE_FINISH


OutFile WinDecryptoSetup.exe
Name WinDecrypto


;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------

;--------------------------------
;Installer Sections

Section "Dummy Section" SecDummy

  SetOutPath "$INSTDIR"

  Call DetectJRE
  
  ;ADD YOUR OWN FILES HERE...
  File /a WinDecrypto.exe
  File /a ..\english-standard.dat
  File /a ..\english4.sta
  File /a ..\english4ns.sta
  File /a ..\gramfreq5ns.stb
  File /a ..\gramfreq5.stb
  File /a ..\decrypto.jar

  ;Store installation folder
  WriteRegStr HKCU "Software\WinDecrypto" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Create short cuts
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\WinDecrypto.lnk" "$INSTDIR\WinDecrypto.exe"
    CreateShortCut "$DESKTOP\WinDecrypto.lnk" "$INSTDIR\WinDecrypto.exe"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  
  !insertmacro MUI_STARTMENU_WRITE_END


SectionEnd

###########################################################



;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Files to install...
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  Delete "$INSTDIR\WinDecrypto.exe"
  Delete "$INSTDIR\english-standard.dat"
  Delete "$INSTDIR\english4.sta"
  Delete "$INSTDIR\english4ns.sta"
  Delete "$INSTDIR\gramfreq5ns.stb"
  Delete "$INSTDIR\gramfreq5.stb"
  Delete "$INSTDIR\decrypto.jar"
  Delete "$INSTDIR\Uninstall.exe"

  RMDir "$INSTDIR"
  !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP
    
  Delete "$SMPROGRAMS\$MUI_TEMP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$MUI_TEMP\WinDecrypto.lnk"
  Delete "$DESKTOP\WinDecrypto.lnk"	

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;Delete empty start menu parent diretories
  StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"
 
  startMenuDeleteLoop:
    ClearErrors
    RMDir $MUI_TEMP
    GetFullPathName $MUI_TEMP "$MUI_TEMP\.."
    
    IfErrors startMenuDeleteLoopDone
  
    StrCmp $MUI_TEMP $SMPROGRAMS startMenuDeleteLoopDone startMenuDeleteLoop
  startMenuDeleteLoopDone:
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  DeleteRegKey /ifempty HKCU "Software\WinDecrypto"

SectionEnd


Function GetJRE
        MessageBox MB_OK "WinDecrypto uses Java, which is not installed. Aborting installation. Please visit http://java.sun.com."
 	Quit
FunctionEnd
 
 
Function DetectJRE
  ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" \
             "CurrentVersion"
StrCmp $2 "1.5" done
StrCmp $2 "1.6" done
StrCmp $2 "1.7" done

  Call GetJRE
  
  done:
FunctionEnd
